%define subrel  1
%define zmuid   apache
%define zmgid   apache
%define uname   ZoneMinder
%define moover  1.3.2
%define camver  0.936
#define githash
%define rel     1

%global __requires_exclude perl\\(ZoneMinder|perl\\(ONVIF|perl\\(WSNotification|perl\\(WSDiscovery|perl\\(WSDiscovery10|perl\\(WSSecurity
%global __provides_exclude perl\\(ZoneMinder|perl\\(ONVIF|perl\\(WSNotification|perl\\(WSDiscovery|perl\\(WSDiscovery10|perl\\(WSSecurity

Name:           zoneminder
Version:        1.30.4
Release:        %mkrel %{rel}%{?githash:.%{githash}}
Summary:        Video Camera and CCTV Security with Motion Detection
Group:          Security
URL:            http://www.zoneminder.com/
License:        GPLv2+ and MIT
# Included Mootools is under the MIT license: http://mootools.net/
# http://www.opensource.org/licenses/mit-license.php
%if %{defined githash}
Source0:        %{uname}-%{version}-%{githash}.tar.gz
%else
## NOTE Use mk-tar script to create tarball as upstream release tarball excludes git submodules
## NOTE Do not use mgarepo sync -d
Source0:        https://github.com/%{uname}/%{uname}/releases/download/v%{version}/%{uname}-%{version}.tar.gz
%endif
Source1:        www.charliemouse.com/code/cambozola/cambozola-%{camver}.tar.gz
Source2:        %{name}.conf
Source3:        redalert.wav
Source4:        README.Mageia
Source6:        zmrestart
Source7:        zmstop
Source8:        zmsetup
Source9:        %{name}.service
Source10:       %{name}-tmpfiles.conf
Source11:       89-%{name}.rules
Source12:       README.1.27.Mageia
Source13:       mk-tar

Patch0:         zoneminder-1.30.0-gcrypt.patch

BuildRequires:  ant
BuildRequires:  cmake
# ffmpeg is needed for CMakeLists.txt to set OPT_FFMPEG
BuildRequires:  ffmpeg
BuildRequires:  ffmpeg-devel
BuildRequires:  gnutls-devel
BuildRequires:  java-devel >= 1:1.7.0
BuildRequires:  jpeg-devel
BuildRequires:  libgcrypt-devel
BuildRequires:  mariadb-devel
BuildRequires:  pcre-devel
BuildRequires:  pkgconfig(libcurl)
BuildRequires:  pkgconfig(libvlc)
BuildRequires:  pkgconfig(polkit-gobject-1)
# Perl modules really required for build
BuildRequires:  perl(Date::Manip)
BuildRequires:  perl(DBD::mysql)
BuildRequires:  perl(LWP::UserAgent)
BuildRequires:  perl(Sys::Mmap)

Requires:       apache-mod_php
Requires:       cracklib-dicts
Requires:       ffmpeg
# Perl modules required but not auto-required
Requires:       perl(Archive::Zip)
Requires:       perl(DBD::mysql)
Requires:       perl(IO::Socket::SSL)
Requires:       perl(MIME::Entity)
Requires:       perl(MIME::Lite)
Requires:       perl(Net::FTP)
Requires:       perl(Net::SFTP::Foreign)
Requires:       perl(PHP::Serialization)
Requires:       perl(Sys::CPU)
Requires:       perl(Sys::MemInfo)

Requires:       php
Requires:       php-apcu
Requires:       php-gd
Requires:       php-mysql
Requires:       php-pdo_mysql
Requires:       php-pdo
Requires:       php-sockets


Requires(post): rpm-helper >= %{rpmhelper_required_version}
Requires(preun): rpm-helper >= %{rpmhelper_required_version}

Recommends:     mysql

%description
A CCTV security package with remote access, motion detection and recording.
ZoneMinder is intended for use in single or multi-camera video security
applications, including commercial or home CCTV. It supports capture,
analysis, recording, and monitoring of video data coming from one or more
video or network cameras attached to a Linux system. 
ZoneMinder also supports web and semi-automatic control of Pan/Tilt/Zoom
cameras using a variety of protocols.
It is designed to run on distributions which support the Video For Linux (V4L)
interface and has been tested with video cameras attached to BTTV cards,
various USB cameras and also supports most IP network cameras.

%prep
%setup -q -a 1 -n %{uname}-%{version}

%autopatch -p1

# Change the following default values
./utils/zmeditconfigdata.sh ZM_PATH_ZMS /zmcgi/nph-zms
./utils/zmeditconfigdata.sh ZM_OPT_CAMBOZOLA yes
./utils/zmeditconfigdata.sh ZM_HTTP_VERSION 1.1
./utils/zmeditconfigdata.sh ZM_CHECK_FOR_UPDATES no
./utils/zmeditconfigdata.sh ZM_DYN_SHOW_DONATE_REMINDER no
./utils/zmeditconfigdata.sh WEB_ALARM_SOUND %{_datadir}/%{name}/sounds/redalert.wav
./utils/zmeditconfigdata.sh ZM_ENABLE_CSRF_MAGIC yes

cp %{SOURCE4} README.Mageia
cp %{SOURCE12} README.1.27.Mageia

%build
pushd cambozola-%{camver}
%ant
popd

%cmake \
-DCMAKE_INSTALL_LIBDIR=lib \
-DCMAKE_INSTALL_PREFIX=%{_usr} \
-DZM_CGIDIR=%{_datadir}/%{name}/cgi \
-DZM_WEBDIR=%{_datadir}/%{name}/www \
-DZM_WEB_USER=%{zmuid} \
-DZM_WEB_GROUP=%{zmgid} \
-DZM_CONFIG_DIR=%{_sysconfdir}

%make_build

%install
%make_install -C build

for dir in events images temp  ; do
    install -m 755 -d %{buildroot}%{_localstatedir}/lib/%{name}/$dir
    ln -sf %{_localstatedir}/lib/%{name}/$dir %{buildroot}%{_datadir}/%{name}/www/$dir
done

install -D -m 775 cambozola-%{camver}/dist/cambozola.jar \
%{buildroot}/%{_datadir}/%{name}/www/cambozola.jar
install -d -m 755 %{buildroot}%{_datadir}/%{name}
install -d -m 755 db %{buildroot}%{_datadir}/%{name}/db
install -m 644 db/*.sql %{buildroot}%{_datadir}/%{name}/db
install -D -m 644 %{SOURCE2} %{buildroot}%{_webappconfdir}/%{name}.conf
install -D -m 755 %{SOURCE3} %{buildroot}%{_datadir}/%{name}/sounds/redalert.wav
install -d -m 755 %{buildroot}%{_localstatedir}/log/zm
install -D -m 755 %{SOURCE6} %{buildroot}%{_bindir}/zmrestart
install -D -m 755 %{SOURCE7} %{buildroot}%{_bindir}/zmstop
install -D -m 755 %{SOURCE8} %{buildroot}%{_bindir}/zmsetup
install -D -m 644 scripts/zmlogrotate.conf.in %{buildroot}%{_sysconfdir}/logrotate.d/zm
install -D -m 644 %{SOURCE9} %{buildroot}%{_unitdir}/%{name}.service
install -m 755 -d %{buildroot}/var/lib/%{name}/sock
install -m 755 -d %{buildroot}/var/lib/%{name}/swap
install -m 755 -d %{buildroot}/var/lib/%{name}/temp
install -m 755 -d %{buildroot}/var/spool/%{name}-upload
install -D -p -m 0644 %{SOURCE10} %{buildroot}%{_tmpfilesdir}/%{name}.conf
install -d -m 755 %{buildroot}%{_udevrulesdir}
install -D -p -m 0644 %{SOURCE11} %{buildroot}%{_udevrulesdir}/89-%{name}.rules

cat > README.urpmi <<EOF

ZoneMinder is now installed.
Mageia has included a script to simplify setup.
It will:
* Help you to create a mysql root password, a new ZoneMinder
  mysql database, or update from a previously installed version.
* Set mysql permissions for the zoneminder user.
* Start Mysql, Apache and ZoneMinder on completion.

To use it enter the following commands in a terminal:-

su

zmsetup

NOTE: After updating ZoneMinder to a new version always run zmsetup
and select to re-use your existing database. This will allow you
to update the database to be compatible with the newly installed
version of ZoneMinder, while keeping your existing events and
settings.

EOF

%post
%_tmpfilescreate %{name}

# Make sure that service is not automatically re-started on update as
# zmsetup should be run before re-starting to avoid db errors.
if [ $1 -eq 2 ]; then
systemctl stop %{name}.service > /dev/null 2>&1
fi

%_post_service %{name}

%preun
%_preun_service %{name}

%files
%doc AUTHORS README.md README.Mageia README.urpmi README.1.27.Mageia
%config(noreplace) %attr(640,root,%{zmgid}) %{_sysconfdir}/zm.conf
%config(noreplace) %{_webappconfdir}/%{name}.conf
%{_bindir}/zma
%{_bindir}/zmaudit.pl
%{_bindir}/zmc
%{_bindir}/zmcontrol.pl
%{_bindir}/zmdc.pl
%{_bindir}/zmf
%{_bindir}/zmfilter.pl
%{_bindir}/zmcamtool.pl
%{_bindir}/zmpkg.pl
%{_bindir}/zmtrack.pl
%{_bindir}/zmtrigger.pl
%{_bindir}/zmu
%{_bindir}/zmupdate.pl
%{_bindir}/zmvideo.pl
%{_bindir}/zmwatch.pl
%{_bindir}/zmsetup
%{_bindir}/zmstop
%{_bindir}/zmrestart
%{_bindir}/zmx10.pl
%{_bindir}/zmsystemctl.pl
%{_bindir}/zmonvif-probe.pl
%{_bindir}/zmtelemetry.pl

%{_unitdir}/%{name}.service
%{perl_vendorlib}/*
%{_mandir}/man*/*

%dir %attr(755,%{zmuid},%{zmgid}) %{_datadir}/%{name}
%attr(755,%{zmuid},%{zmgid}) %dir %{_datadir}/%{name}/www
%attr(755,%{zmuid},%{zmgid}) %{_datadir}/%{name}/www/*
%{_datadir}/%{name}/db
%{_datadir}/%{name}/sounds
%{_datadir}/%{name}/cgi

%dir %attr(755,%{zmuid},%{zmgid}) %dir %{_localstatedir}/log/zm
%dir %attr(755,%{zmuid},%{zmgid}) %{_localstatedir}/lib/%{name}
%dir %attr(755,%{zmuid},%{zmgid}) %{_localstatedir}/lib/%{name}/events
%dir %attr(755,%{zmuid},%{zmgid}) %{_localstatedir}/lib/%{name}/images
%dir %attr(755,%{zmuid},%{zmgid}) %{_localstatedir}/lib/%{name}/sock
%dir %attr(755,%{zmuid},%{zmgid}) %{_localstatedir}/lib/%{name}/swap
%dir %attr(755,%{zmuid},%{zmgid}) %{_localstatedir}/lib/%{name}/temp
%dir %attr(755,%{zmuid},%{zmgid}) %{_localstatedir}/spool/%{name}-upload
%{_sysconfdir}/logrotate.d/zm
%{_udevrulesdir}/89-%{name}.rules
%{_tmpfilesdir}/%{name}.conf
%{_datadir}/polkit-1/rules.d/com.zoneminder.systemctl.rules
%{_datadir}/polkit-1/actions/com.zoneminder.systemctl.policy


%changelog
* Thu May 18 2017 barjac <barjac> 1.30.4-1.1.mga5
+ Revision: 1103170
- Oops - really update zmsetup and README.Mageia
- new version 1.30.4
- replaces 1.30.3 which was flawed upstream
- patch removed, merged upstream
- new version 1.30.3
- fixes CVE-2017-7203 Cross-Site Scripting (XSS)
- fixes CVE-2017-5367 Multiple reflected XSS
- fixes CVE-2017-5595 File disclosure and inclusion vulnerability (patch merged upstream)
- fixes CVE-2016-10204 SQL injection vulnerability
- fixes CVE-2016-10205 Session fixation vulnerability
- fixes CVE-2017-5368, CVE-2016-10206 CRSF mitigation
- new Require: php-apcu
- CRSF Magic enabled by default
- mk-tar script added to create tarball with git submodules included
- Fixes Mga#20215 (The above multiple CVEs)
- fix perl Requires not found by autoreq
- Use perl(x::x) format for all perl (Build)Requires

* Wed Nov 26 2014 barjac <barjac> 1.28.0-2.33f3612.mga5
+ Revision: 799347
- inhibit systemctl warning on updates
- update snapshot to really fix groups issue

* Tue Nov 25 2014 barjac <barjac> 1.28.0-1.1a74a41.mga5
+ Revision: 798863
- new version 1.28
- move some temporary files to /run/zm
- use new upstream script to change some defaults in spec rather than patching
- fixes upstream bugs including some massive logs
- allows non-admin users to create monitor groups
- added code in zmsetup to allow smooth updates from 1.27 to 1.28 to preserve existing database

* Sat Nov 15 2014 barjac <barjac> 1.27.99.0-7.1076a62.mga5
+ Revision: 797330
- rebuild for new ffmpeg

* Wed Oct 15 2014 umeabot <umeabot> 1.27.99.0-6.1076a62.mga5
+ Revision: 749720
- Second Mageia 5 Mass Rebuild

* Wed Oct 01 2014 tv <tv> 1.27.99.0-5.1076a62.mga5
+ Revision: 734258
- rebuild for pear deps

* Fri Sep 26 2014 tv <tv> 1.27.99.0-4.1076a62.mga5
+ Revision: 725323
- rebuild for bogus file deps

* Tue Sep 16 2014 umeabot <umeabot> 1.27.99.0-3.1076a62.mga5
+ Revision: 690886
- Mageia 5 Mass Rebuild

  + tv <tv>
    - s/uggests:/Recommends:/

* Wed Sep 10 2014 barjac <barjac> 1.27.99.0-2.1076a62.mga5
+ Revision: 674467
- correct formatting of README.urpmi

* Tue Sep 09 2014 barjac <barjac> 1.27.99.0-1.1076a62.mga5
+ Revision: 674210
- new git snapshot
- new mootools version 1.5.1
- new cambozola version 0.935
- moved udev rules up to 89-zoneminder from 59- to fix rule being overwritten
- new BR pkgconfig(polkit-gobject-1)
- new Requires: php-pdo php-pdo-mysql
- updated README.urpmi
- new polkit rules from upstream to handle web UI start/stopping service
- make not needed with %%cmake

* Mon Apr 07 2014 barjac <barjac> 1.27.0-4.mga5
+ Revision: 612690
- change udev rule to set acl for apache group not user
- rename udev rule to 59-zoneminder.rules or it clobbers the uaccess rule
- add three upstream git patches to fix playback control button bugs

* Tue Mar 25 2014 barjac <barjac> 1.27.0-3.mga5
+ Revision: 608704
- fix logs path on update from < 1.27 in zmsetup

* Tue Mar 25 2014 barjac <barjac> 1.27.0-2.mga5
+ Revision: 608559
- fix rewind bug with upstream git patch

* Mon Mar 24 2014 barjac <barjac> 1.27.0-1.mga5
+ Revision: 608161
- new version 1.27.0 and major overhaul
- switched to cmake
- web files removed from web root in line with webapps policy
- zoneminder cgi scipts moved out of cgi-bin and ScriptAliased
- /dev/videoX perms handled with udev rule and acl
- updates from < 1.27.0 handled with change to zmsetup
- README.1.27.Mageia added for this release
- added BR ffmpeg needed for CMakeLists detection
- added BRs libvlc and libcurl
- fix files list
- drop X10 support
- drop donate nag from default install
- drop update nag from default install

* Tue Dec 03 2013 barjac <barjac> 1.26.4-2.mga4
+ Revision: 554854
- remove un-needed ScriptAlias
- change some default configs
- fix tempfiles installation
- remove un-needed perl buildrequires and requires
- build in X10 support
- dont disable crashtrace as it does not impact performance
- dont own cgi-bin

* Sat Oct 26 2013 barjac <barjac> 1.26.4-1.mga4
+ Revision: 547037
- new release 1.26.4
- patched to git-3502 with further bug fixes

* Sat Oct 19 2013 umeabot <umeabot> 1.26.3-2.mga4
+ Revision: 535086
- Mageia 4 Mass Rebuild

* Wed Sep 18 2013 barjac <barjac> 1.26.3-1.mga4
+ Revision: 481053
- new version
- give zmuser alter rights
- change zmupdate to use zm user in zmconf to update db
- patch to fix minor bug in db update from 1.26.0

* Thu Sep 05 2013 barjac <barjac> 1.26.0-1.mga4.tainted
+ Revision: 475298
- update to full release 1.26.0
- remove CVE-2013-0232 patch applied upstream
- remove automake-1.13 patch applied upstream

* Sat Aug 31 2013 barjac <barjac> 1.26.0-0.beta.3.1.mga4.tainted
+ Revision: 473592
- new version 1.26.0 beta 3
- removed obsolete patches
- re-diffed autotools patch to -p1 for %%apply_patches
- updated mootools to version 1.2.6
- updated cambozola to version 0.931
- modified spec to cope cleanly with pre-release betas etc.
- added mk-git-tar script to create pre-release tarballs
- removed README and added README.md
- re-enumerated patches

* Mon Jul 15 2013 fwang <fwang> 1.25.0-23.mga4.tainted
+ Revision: 454494
- more fix for ffmpeg 2.0
- fix build with new ffmpeg
- use force install

* Fri Mar 22 2013 barjac <barjac> 1.25.0-23.mga3.tainted
+ Revision: 404522
- check for mysql in zmsetup and offer to install
- suggest mysql

* Sat Mar 16 2013 barjac <barjac> 1.25.0-22.mga3.tainted
+ Revision: 403486
- patch - CVE-2013-0232 (arbitrary command execution vulnerability)

* Mon Jan 14 2013 umeabot <umeabot> 1.25.0-21.mga3.tainted
+ Revision: 387773
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 08 2013 fwang <fwang> 1.25.0-20.mga3.tainted
+ Revision: 341755
- rebuild for new ffmpeg

* Sat Jan 05 2013 barjac <barjac> 1.25.0-19.mga3.tainted
+ Revision: 338866
- fix build with automake-1.13
- re-enumerate patches

  + kamil <kamil>
    - add P10: zoneminder-1.25.0-mga-fix-build-with-automake-1.13.patch

* Sat Dec 01 2012 fwang <fwang> 1.25.0-18.mga3.tainted
+ Revision: 323865
- there is no ffmpeg-static
- rebuild for new pcre

* Thu Sep 27 2012 barjac <barjac> 1.25.0-17.mga3.tainted
+ Revision: 298811
- Change group from Video to Security to fit new policy

* Wed Sep 26 2012 barjac <barjac> 1.25.0-16.mga3
+ Revision: 297850
- Added BR/Requires on turbo-jpeg for improved performance

* Tue Sep 11 2012 guillomovitch <guillomovitch> 1.25.0-15.mga3.tainted
+ Revision: 292434
- drop useless explicit perl dependencies computed automatically

* Tue Sep 11 2012 barjac <barjac> 1.25.0-15.mga3
+ Revision: 292235
- Patch to work around v4l2 api breakage in 3.5 kernel
- Removed stray patch that was re-named a while back

  + guillomovitch <guillomovitch>
    - renumerate sources for sake of readability
    - cleanup files part
    - no dependency on mysql
    - cleanup setup part
    - don't replicate %%configure arguments
    - cleanup installation
    - drop sysinit support
    - use _webappconfdir macro

* Wed Jul 25 2012 barjac <barjac> 1.25.0-14.mga3.tainted
+ Revision: 274157
- new perfpatch with deinterlace
- new version of mootools and define for version
- added define for cambozala version
- improved systemd unit file to not need zmstop
- changed zmstop utility to use systemctl
- include ffmpeg in core build
- remove gcc4.7 patches as now in perfpatch
- remove avcodec detect patch as now in perfpatch
- drop lmp3lame in tainted as not needed
- remove unneeded BR ffmpeg
- moved zoneminder.conf to sites.d
- updated zoneminder.conf for apache 2.4
- added min version require for apache >= 2.4

* Mon Jul 16 2012 barjac <barjac> 1.25.0-13.mga3.tainted
+ Revision: 271539
- re-name ffmpeg patch for consistency - and policy
- fix warnings in cambozala build with BR on minimum JDK version

* Mon Jul 16 2012 barjac <barjac> 1.25.0-12.mga3.tainted
+ Revision: 271422
- modified and re-added ffmpeg patch to not add includes
- remove BR ffmpeg-static-devel
- Patched configure.ac to correctly detect presence of libavcodec

  + neoclust <neoclust>
    - Start to port to new ffmpeg

* Tue Jul 10 2012 barjac <barjac> 1.25.0-11.mga3
+ Revision: 269149
- rebuild against gcc-4.7
- patched to fix build fail due to missing includes in gcc-4.7
- fix from bug 6462 mga2 applied to mga3

* Fri May 11 2012 barjac <barjac> 1.25.0-10.mga2.tainted
+ Revision: 235332
- Fix in unit file for bug #5805

* Sat Apr 28 2012 tmb <tmb> 1.25.0-9.mga2.tainted
+ Revision: 233913
- Require rpm-helper >= 0.24.8-1 for systemd support

* Mon Apr 09 2012 barjac <barjac> 1.25.0-8.mga2.tainted
+ Revision: 229835
- new perfpatch with various bug fixes
- fix spec bugs that installed a makefile and left a stray folder after uninstall
- improved README.mageia
- removed old patches that are now included in patch0

  + dmorgan <dmorgan>
    - Add ExecReload support in systemd file ( Fedora)

* Mon Feb 20 2012 barjac <barjac> 1.25.0-7.mga2.tainted
+ Revision: 211184
- Patch to fix bug in zmwatch.js that was filling error log
- Added User= to unit file to fix zm processes running with wrong cgroup
- Added ExecStop= to unit file to allow systemctl to stop zm processes correctly
- Fix typo in zmrestart script that was giving wrong error message

* Mon Jan 30 2012 barjac <barjac> 1.25.0-6.mga2.tainted
+ Revision: 203335
- Fix bug (typo) in zmsetup script

* Sat Jan 21 2012 barjac <barjac> 1.25.0-5.mga2.tainted
+ Revision: 199305
- Updated zmsetup and zmrestart scripts to systemd

* Thu Dec 22 2011 barjac <barjac> 1.25.0-4.mga2.tainted
+ Revision: 185583
- Added performance patch - bump release

* Tue Dec 20 2011 barjac <barjac> 1.25.0-3.mga2.tainted
+ Revision: 184679
- Rebuild against mariadb
- Minor text edit in spec

* Fri Nov 04 2011 shlomif <shlomif> 1.25.0-2.mga2.tainted
+ Revision: 162984
- Fixed the /tmp thing.
- New mkrel for rebuild due to package failure
- New version with systemd support.

* Thu Oct 06 2011 shlomif <shlomif> 1.24.4-8.mga2.tainted
+ Revision: 152451
- Fixed bugs in zmsetup and zmupdate.pl, added logrotate, added LSB header to init. Thanks to barjac.

* Fri Sep 23 2011 shlomif <shlomif> 1.24.4-7.mga2.tainted
+ Revision: 147001
- Add perl-X10 as requires. Thanks to barjac
- imported package zoneminder



* Tue Sep 20 2011 Barry Jackson <zen25000@zen.co.uk> - 1.24.4-6
- cambozola.jar removed from SOURCES and now built from source. 

* Mon Sep 19 2011 Barry Jackson <zen25000@zen.co.uk> - 1.24.4-5
- Corrections to BuildRequires and Requires

* Fri Sep 16 2011 Barry Jackson <zen25000@zen.co.uk> - 1.24.4-4
- Patched to avoid format-security errors when using configure macro.
- Removed hostname feature from zmsetup as beyond scope.

* Thu Sep 15 2011 Barry Jackson <zen25000@zen.co.uk> - 1.24.4-3
- Corrected various source permissions and description line lengths.
- Improved zmsetup to change hostname if required.
- Removed requirement for sse2

* Tue Sep 13 2011 Barry Jackson <zen25000@zen.co.uk> - 1.24.4-2
- Removed jscalendar as it is apparently not requiired.
- Added zmrestart script as it can be useful.

* Sun Sep 11 2011 Barry Jackson <zen25000@zen.co.uk> - 1.24.4-1
- Added Require: php-sockets, README.urpmi, distro_section for tainted builds.

* Thu Sep 8 2011 Barry Jackson <zen25000@zen.co.uk> - 1.24.4-0
- New package for Mageia. 
- Includes the performance patch by Kfir Itzhak :-
- http://www.zoneminder.com/forums/viewtopic.php?f=9&t=17652

